/***************************************************************************
Name: JSView
Version: 1.4
Description: Allows you to view the source code of external js and css files
Author: Ron Beckman
Homepage: http://forum.softwareblaze.com
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/



window.addEventListener("load", jsviewLoad, false);

function jsviewLoad() {
	gBrowser.addProgressListener(jsviewProgress);
	jsview.jsviewInit();
}

window.addEventListener("unload", jsviewUnload, false);

function jsviewUnload() {
	gBrowser.removeProgressListener(jsviewProgress);
}

function checkPageStatus() {
	var a = jsviewProgress.webprog;
	if ((a && !a.isLoadingDocument) || !a) {
		jsview.jsviewOnload();
	}
}

var jsviewProgress = {

	webprog: null,

	QueryInterface: function(aIID) {
		if (aIID.equals(Components.interfaces.nsIWebProgressListener)   ||
		aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		aIID.equals(Components.interfaces.nsISupports))
			return this;
		throw Components.results.NS_NOINTERFACE;
	},

	onLinkIconAvailable: function(a) { },
	onLocationChange: function(a,b,c) {
		this.webprog = a;
		window.setTimeout(checkPageStatus,200);
	},

	onProgressChange: function(a,b,c,d,e,f) { },
	onSecurityChange: function(a,b,c) { },
	onStateChange: function(a,b,c,d) {
		if ((a && !a.isLoadingDocument) || !a) {
			jsview.jsviewOnload();
		}
	},
	onStatusChange: function(a,b,c,d) { }
};

function jsviewRequestObserver() {}

jsviewRequestObserver.prototype = {

	onStartRequest: function(request, ctxt) { },

	onStopRequest: function(request, ctxt, status) {
		var linkChecker = request.QueryInterface(Components.interfaces.nsIURIChecker);
		if (linkChecker && status==0) {
			//do this
		}
	}
};

var jsview = {

	getClipboard: function() {
		return Components.classes["@mozilla.org/widget/clipboardhelper;1"].
		getService(Components.interfaces.nsIClipboardHelper);
	},

	getUriChecker: function() {
		return Components.classes['@mozilla.org/network/urichecker;1'].
		createInstance(Components.interfaces.nsIURIChecker);
	},

	getURI: function(url) {
		return Components.classes["@mozilla.org/network/io-service;1"].
		getService(Components.interfaces.nsIIOService).
		newURI(url,null,null);
	},

	objectRef: function() {
		var url = window.content.document.location.href;
		var arg1 = 'top.frames[1]';
		window.openDialog('chrome://jsview/content/jsviewObjRef.xul','ObjRef','chrome,resizable=yes,centerscreen',arg1,url);
	},

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("jsview.");
	},

	getCacheService: function() {
		return Components.classes["@mozilla.org/network/cache-service;1"].
		getService(Components.interfaces.nsICacheService).
		createSession("HTTP", 0, true);
	},

	getMainWin: function() {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator).
		getMostRecentWindow("navigator:browser");
	},

	getSt: function(name) {
		return document.getElementById("jsview-bundle").getString(name);
	},

	getBrowsName: function() {
		return document.getElementById("bundle_brand").getString('brandShortName');
	},

	addCommas: function(num) {
		num = num.toString();
		var x = num.split('.');
		var x1 = x[0];
		var x2 = x.length > 1 ? '.' + x[1] : '';
		var rgx = /(\d+)(\d{3})/;
		while (rgx.test(x1)) {
			x1 = x1.replace(rgx, '$1' + ',' + '$2');
		}
		return x1 + x2;
	},

	viewSourceOfURL: function(url) {
		var brows = this.getBrowsName();
		if (brows=='SeaMonkey') {
			openDialog("chrome://navigator/content/viewSource.xul",
			"_blank",
			"all,dialog=no",
			url, null, null, gBrowser.mCurrentTab.linkedPanel);
		} else {
			openDialog("chrome://global/content/viewSource.xul",
			"_blank",
			"all,dialog=no",
			url, null, null, gBrowser.mCurrentTab.linkedPanel);
		}
	},

	jsviewMain: function(arg) {
		var prefs = this.getPrefs();
		var win = this.getMainWin();

		var ext,param;
		var behavior = prefs.getCharPref('chooseBehavior');
		var one = this.getSt('jsview.OpenBlur');
		var two = this.getSt('jsview.OpenFocus');
		var three = this.getSt('jsview.External');

		if (behavior==one) {
			ext = arg.substr(-3);
			param = arg.substr(-7);
			if (ext!='css' && ext!='.js' &&
			    param!='?jsview' && param!='&jsview') arg = 'view-source:'+arg;
			(arg.search(/\?/)==-1) ? arg+='?jsview' : arg+='&jsview';
			win.getBrowser().addTab(arg);
		} else if (behavior==two) {
			ext = arg.substr(-3);
			param = arg.substr(-7);
			if (ext!='css' && ext!='.js' &&
			    param!='?jsview' && param!='&jsview') arg = 'view-source:'+arg;
			(arg.search(/\?/)==-1) ? arg+='?jsview' : arg+='&jsview';
			var newTab = win.getBrowser().addTab(arg);
			win.getBrowser().selectedTab = newTab;
		} else if (behavior==three) {
			jsviewOpenExt.openInExternalEditor(arg);
		} else {
			this.viewSourceOfURL(arg);
		}
	},

	jsviewOpenAllJS: function() {
		var js = this.isJSExternal();
		var i;
		for (i=0; i<js.length; ++i) {
			setTimeout("jsview.jsviewMain('"+js[i]+"')",i*500);
		}
	},

	jsviewOpenAllCSS: function() {
		var css = this.isCSSExternal();
		var i;
		for (i=0; i<css.length; ++i) {
			setTimeout("jsview.jsviewMain('"+css[i]+"')",i*500);
		}
	},

	jsviewInit: function() {
		var prefs = this.getPrefs();

		//add onclick event to popup menu for users who cannot use popupshowing
		if (prefs.getBoolPref('activateOnclick')) {
			document.getElementById('jsview-status').setAttribute('onclick','jsview.jsviewStatus();');
		}

		var toolsmenupref = prefs.getBoolPref('disableToolsOptions');
		var jsviewtoolsoptions = document.getElementById('jsview-options');

		var contextpref = prefs.getBoolPref("disableContext");
		var contextmenu = document.getElementById("contentAreaContextMenu");

		var toolbar = document.getElementById('menu_viewPopup') ||
			        document.getElementById('menu_View_Popup');

		var buttonpopup = document.getElementById('jsview-button-popup');

		var statuspref = prefs.getBoolPref("disableStatus");
		var status = document.getElementById('jsview-status');
		var statuspopup = document.getElementById('jsview-status-popup');

		if (contextmenu) {
			contextmenu.addEventListener("popupshowing", jsviewListen.EECL, false);
			if (!contextpref) {
				contextmenu.addEventListener("popupshowing", jsviewListen.CL, false);
			} else {
				document.getElementById('jsview-context-menu').setAttribute('hidden',true);
				document.getElementById('cssview-context-menu').setAttribute('hidden',true);
			}
		}

		if (toolbar) {
			toolbar.addEventListener("popupshowing", jsviewListen.TL, false);
		} else {
			document.getElementById('jsview-toolbar-menu').setAttribute('hidden',true);
			document.getElementById('cssview-toolbar-menu').setAttribute('hidden',true);
		}

		if (buttonpopup) {
			buttonpopup.addEventListener("popupshowing", jsviewListen.BL, false);
		}

		if (!statuspref && statuspopup) {
			statuspopup.addEventListener("popupshowing", jsviewListen.SL, false);
		} else if (status) {
			status.setAttribute('hidden',true);
		}

		if (!toolsmenupref && jsviewtoolsoptions) {
			jsviewtoolsoptions.setAttribute('hidden',false);
		} else {
			jsviewtoolsoptions.setAttribute('hidden',true);
		}
	},

	createMenuItems: function(a,b,c) {
		//a=js or css, b=popup id, c=true or false (true will remove existing menu items)

		var list,va,vaU,menu,temp,noname,kb,bytes,prefs,filesize,uri,checker;
		var cacheServ,name,cacheKey,descriptor,pageSize,kbSize,size;

		list = (a=='js') ? this.isJSExternal() : this.isCSSExternal();
		va = (a=='js') ? 'Js' : 'Css';
		vaU = va.toUpperCase();
		menu = document.getElementById(b);

		if (c) {
			while (menu.firstChild) {
				menu.removeChild(menu.firstChild);
			}
		}

		if (!list.length) {
			temp = document.createElement('menuitem');
			temp.setAttribute('label',this.getSt('jsview.'+va+'NF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.'+va+'NF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			menu.appendChild(temp);
			return false;
		}

		noname = this.getSt('jsview.NoName');
		kb = this.getSt('jsview.KB');
		bytes = this.getSt('jsview.Bytes');

		prefs = this.getPrefs();
		filesize = prefs.getBoolPref('fileSize');

		cacheServ = this.getCacheService();

		temp = document.createElement('menuitem');
		temp.setAttribute('label',this.getSt('jsview.ViewAll'+va));
		temp.setAttribute('oncommand',"jsview.jsviewOpenAll"+vaU+"()");
		temp.setAttribute('image','chrome://jsview/skin/'+a+'.gif');
		temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAll'+va));
		temp.setAttribute('style','font-weight:900;');
		temp.setAttribute('class','menuitem-iconic');
		menu.appendChild(temp);

		for (var i=0; i<list.length; ++i) {
			//validate existence of uri, this will be implemented in a future version
			/*uri = this.getURI(list[i]);
			checker = this.getUriChecker();
			checker.init(uri);
			checker.asyncCheck(new jsviewRequestObserver(), null);*/

			//remove parameters and add missing filenames
			name = list[i];
			if (name.indexOf('?')!=-1) name = name.substr(0,name.indexOf('?'));
			name = name.substr(name.lastIndexOf('/')+1);
			if (!name) name = '['+noname+']';

			//retrieve file size if cached
			cacheKey = list[i].replace(/#.*$/, "");
			try {
				descriptor = cacheServ.openCacheEntry(cacheKey, Components.interfaces.nsICache.ACCESS_READ, false);
			} catch(e) { descriptor = ''; }
			if (descriptor) {
				pageSize = this.addCommas(descriptor.dataSize);
				kbSize = (descriptor.dataSize / 1024).toFixed(2);
				size = (filesize) ? ' ('+kbSize+' '+kb+')' : ' ('+pageSize+' '+bytes+')';
			} else {
				size = '';
			}

			temp = document.createElement('menuitem');
			temp.setAttribute('label',name+size);
			temp.setAttribute('oncommand',"jsview.jsviewMain('"+list[i]+"')");
			temp.setAttribute('image','chrome://jsview/skin/'+a+'.gif');
			temp.setAttribute('tooltiptext',list[i]);
			temp.setAttribute('onmouseover',"document.getElementById('statusbar-display').label='"+list[i]+"';");
			temp.setAttribute('onmouseout',"document.getElementById('statusbar-display').label='"+this.getSt('jsview.Done')+"';");
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('onclick',"if (event.button==1 || event.button==2) {var clip = jsview.getClipboard(); clip.copyString('"+list[i]+"');} return false;");
			if (b.indexOf('toolbar-popup')!=-1) temp.setAttribute('statustext',list[i]);
			if (name=='['+noname+']') temp.setAttribute('style','font-style:italic;');
			menu.appendChild(temp);
		}
		return false;
	},

	extEditorContext: function() {
		var editor = document.getElementById('jsview-editor');
		var source = document.getElementById('jsview-source');

		if (!'target' in gContextMenu || !gContextMenu.target) {
			editor.setAttribute('hidden','true');
			source.setAttribute('hidden','true');
			return false;
		}

		var show = (gContextMenu.inDirList || gContextMenu.onImage || gContextMenu.isContentSelected || gContextMenu.onLink || gContextMenu.onTextInput);

		var loc = gContextMenu.target.ownerDocument.location.href.substr(-7);
		if ((loc=='?jsview' || loc=='&jsview') && !show) {
			editor.setAttribute('hidden','false');
		} else {
			editor.setAttribute('hidden','true');
		}

		var prefs = this.getPrefs();
		if (!show && !prefs.getBoolPref('disableVPS')) {
			source.setAttribute('hidden','false');
		} else {
			source.setAttribute('hidden','true');
		}

		return false;
	},

	jsviewContext: function() {
		//this.extEditorContext();

		var js = this.isJSExternal();
		var css = this.isCSSExternal();
		var jscontext = document.getElementById('jsview-context-menu');
		var csscontext = document.getElementById('cssview-context-menu');
		var show = (gContextMenu.inDirList || gContextMenu.onImage || gContextMenu.isContentSelected || gContextMenu.onLink || gContextMenu.onTextInput);

		if (js.length > 0 && !show) {
			jscontext.setAttribute('hidden',false);
			jscontext.setAttribute('label',this.getSt('jsview.ViewExtJs')+" (" +js.length+ ")");
		} else {
			jscontext.setAttribute('hidden',true);
		}

		if (css.length > 0 && !show) {
			csscontext.setAttribute('hidden',false);
			csscontext.setAttribute('label',this.getSt('jsview.ViewExtCss')+" (" +css.length+ ")");
		} else {
			csscontext.setAttribute('hidden',true);
		}
	},

	jsviewToolbar: function() {
		var js = this.isJSExternal();
		var css = this.isCSSExternal();
		var jstoolbar = document.getElementById('jsview-toolbar-menu');
		var csstoolbar = document.getElementById('cssview-toolbar-menu');

		if (js.length > 0) {
			jstoolbar.setAttribute('hidden',false);
			jstoolbar.setAttribute('label',this.getSt('jsview.ExtJs')+" (" +js.length+ ")");
		} else {
			jstoolbar.setAttribute('hidden',true);
		}

		if (css.length > 0) {
			csstoolbar.setAttribute('hidden',false);
			csstoolbar.setAttribute('label',this.getSt('jsview.ExtCss')+" (" +css.length+ ")");
		} else {
			csstoolbar.setAttribute('hidden',true);
		}
	},

	jsviewButton: function() {
		this.createMenuItems('js','jsview-button-popup',true);

		var btn = document.getElementById('jsview-button-popup');
		var sep = document.createElement('menuseparator');
		btn.appendChild(sep);

		this.createMenuItems('css','jsview-button-popup',false);
	},

	jsviewStatus: function() {
		this.createMenuItems('js','jsview-status-popup',true);

		var sts = document.getElementById('jsview-status-popup');
		var sep = document.createElement('menuseparator');
		sts.appendChild(sep);

		this.createMenuItems('css','jsview-status-popup',false);
	},

	jsviewOnload: function() {
		var js,css;
		var button = document.getElementById('jsview-button');
		var status = document.getElementById('jsview-status');

		try { js = this.isJSExternal(); } catch(e) { js=""; }
		try { css = this.isCSSExternal(); } catch(e) { css=""; }

		if (button) {
			if (js.length > 0 && css.length < 1) {
				button.setAttribute('image',"chrome://jsview/skin/js.gif");
				button.setAttribute('tooltiptext',this.getSt('jsview.ExtJs')+" (" +js.length+ ")");
			} else if (css.length > 0 && js.length < 1) {
				button.setAttribute('image',"chrome://jsview/skin/css.gif");
				button.setAttribute('tooltiptext',this.getSt('jsview.ExtCss')+" (" +css.length+ ")");
			} else if (js.length > 0 && css.length > 0) {
				button.setAttribute('image',"chrome://jsview/skin/both.gif");
				button.setAttribute('tooltiptext',"JS (" +js.length+ ")  CSS (" +css.length+ ")");
			} else {
				button.setAttribute('image',"chrome://jsview/skin/none.gif");
				button.setAttribute('tooltiptext',this.getSt('jsview.NF'));
			}
		}

		if (status && !status.hidden) {
			if (js.length > 0 && css.length < 1) {
				status.setAttribute('src',"chrome://jsview/skin/js.gif");
				status.setAttribute('tooltiptext',this.getSt('jsview.ExtJs')+" (" +js.length+ ")");
			} else if (css.length > 0 && js.length < 1) {
				status.setAttribute('src',"chrome://jsview/skin/css.gif");
				status.setAttribute('tooltiptext',this.getSt('jsview.ExtCss')+" (" +css.length+ ")");
			} else if (js.length > 0 && css.length > 0) {
				status.setAttribute('src',"chrome://jsview/skin/both.gif");
				status.setAttribute('tooltiptext',"JS (" +js.length+ ")  CSS (" +css.length+ ")");
			} else {
				status.setAttribute('src',"chrome://jsview/skin/none.gif");
				status.setAttribute('tooltiptext',this.getSt('jsview.NF'));
			}
		}
	},

	isJSExternal: function() {
		var loc = window.content.document.location.href;
		var scriptarray = [];
		var allscripts,pages,ext,url;

		allscripts = window.content.document.getElementsByTagName('script');
		if (allscripts[0]) {
			for (var i=0; i<allscripts.length; ++i) {
				if (allscripts[i].src && allscripts[i].src!=loc) {
					ext = allscripts[i].src.substr(allscripts[i].src.lastIndexOf('.'));
					if (ext!='.cgi') scriptarray.push(allscripts[i].src);
				}
			}
		}

		pages = window.content.parent.frames;
		if (pages.length > 0) {
			for (var m=0; m<pages.length; ++m) {
				url = pages[m].document.location.href;
				allscripts = pages[m].document.getElementsByTagName('script');
				if (allscripts[0]) {
					for (var i=0; i<allscripts.length; ++i) {
						if (allscripts[i].src && allscripts[i].src!=loc && allscripts[i].src!=url) {
							ext = allscripts[i].src.substr(allscripts[i].src.lastIndexOf('.'));
							if (ext!='.cgi') scriptarray.push(allscripts[i].src);
						}
					}
				}
			}
		}

		//check for duplicate entries and remove them
		scriptarray.sort();
		for (var i=0; i<scriptarray.length-1; ++i) {
			while (scriptarray[i]==scriptarray[i+1]) {
				scriptarray.splice(i,1);
			}
		}

		return scriptarray;
	},

	isCSSExternal: function() {
		var sheets,pages,url;
		var cssarray = [];
		var loc = window.content.document.location.href;

		sheets = window.content.document.styleSheets;
		if (sheets.length > 0) {
			for (var i=0; i<sheets.length; ++i) {
				if (sheets[i].href && sheets[i].href!=loc) {
					cssarray.push(sheets[i].href);
				}
				cssarray = cssarray.concat(this.importedCSS(sheets[i]));
			}
		}

		pages = window.content.parent.frames;
		if (pages.length > 0) {
			for (var m=0; m<pages.length; ++m) {
				url = pages[m].document.location.href;
				sheets = pages[m].document.styleSheets;
				if (sheets.length > 0) {
					for (var i=0; i<sheets.length; ++i) {
						if (sheets[i].href && sheets[i].href!=loc && sheets[i].href!=url) {
							cssarray.push(sheets[i].href);
						}
						cssarray = cssarray.concat(this.importedCSS(sheets[i]));
					}
				}
			}
		}

		//check for duplicate entries and remove them
		cssarray.sort();
		for (var i=0; i<cssarray.length-1; ++i) {
			while (cssarray[i]==cssarray[i+1]) {
				cssarray.splice(i,1);
			}
		}

		return cssarray;
	},

	importedCSS: function(css) {
		var cssarray = [];
		var rules = css.cssRules;
		for (var j=0; j<rules.length; ++j) {
			if (rules[j].type==3) {
				cssarray.push(rules[j].styleSheet.href);
				cssarray = cssarray.concat(this.importedCSS(rules[j].styleSheet));
			} else { break; }
		}
		return cssarray;
	},

	viewOptions: function() {
		window.openDialog('chrome://jsview/content/jsviewOptions.xul',this.getSt('jsview.Options'),'chrome,resizable=yes,centerscreen');
	},

	viewAbout: function() {
		window.openDialog('chrome://jsview/content/about.xul',this.getSt('jsview.About'),'chrome,resizable=yes,centerscreen');
	}
};

var jsviewListen = {

	EECL: function() {
		jsview.extEditorContext();
	},

	CL: function() {
		jsview.jsviewContext();
	},

	TL: function() {
		jsview.jsviewToolbar();
	},

	BL: function() {
		jsview.jsviewButton();
	},

	SL: function() {
		jsview.jsviewStatus();
	}
};