/***************************************************************************
Name: JSView
Version: 1.4
Description: Allows you to view the source code of external js and css files
Author: Ron Beckman
Homepage: http://forum.softwareblaze.com
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/



window.addEventListener('load',jsviewSourceLoad,false);

function jsviewSourceLoad() {
	jsviewVS.init();
}


var jsviewVS = {

	getClipboard: function() {
		return Components.classes["@mozilla.org/widget/clipboardhelper;1"].
		getService(Components.interfaces.nsIClipboardHelper);
	},

	init: function() {
		//add id to menupopup in SeaMonkey
		var sm = document.getElementById('menu_View');
		if (sm) {
			var popup = sm.firstChild;
			if (popup && popup.nodeName=='menupopup' && !popup.id) {
				popup.setAttribute('id','viewmenu-popup');
				document.loadOverlay("chrome://jsview/content/viewsourceOverlay.xul", null);
			}
		}

		var toolbar = document.getElementById('viewmenu-popup') ||
				  document.getElementById('menu_View_Popup');

		if (toolbar) {
			toolbar.addEventListener("popupshowing", jsviewListen.TL, false);
		} else {
			document.getElementById('jsview-toolbar-menu').setAttribute('hidden','true');
			document.getElementById('cssview-toolbar-menu').setAttribute('hidden','true');
		}
	},

	command: function(arg) {
		var win = this.getMainWin();
		if (arg=='jsviewOpenAllJS') {
			win.jsview.jsviewOpenAllJS();
		} else if (arg=='jsviewOpenAllCSS') {
			win.jsview.jsviewOpenAllCSS();
		} else {
			win.jsview.jsviewMain(arg);
		}
	},

	getMainWin: function() {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator).
		getMostRecentWindow("navigator:browser");
	},

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("jsview.");
	},

	getCacheService: function() {
		return Components.classes["@mozilla.org/network/cache-service;1"].
		getService(Components.interfaces.nsICacheService).
		createSession("HTTP", 0, true);
	},

	getSt: function(name) {
		var win = this.getMainWin();
		return win.document.getElementById("jsview-bundle").getString(name);
	},

	addCommas: function(num) {
		num = num.toString();
		var x = num.split('.');
		var x1 = x[0];
		var x2 = x.length > 1 ? '.' + x[1] : '';
		var rgx = /(\d+)(\d{3})/;
		while (rgx.test(x1)) {
			x1 = x1.replace(rgx, '$1' + ',' + '$2');
		}
		return x1 + x2;
	},

	main: function() {
		var win = this.getMainWin();
		win.jsviewOpenExt.openInExternalEditor(window.arguments[0]);
	},

	jsviewToolbar: function() {
		var js = this.isJSExternal();
		var css = this.isCSSExternal();
		var jstoolbar = document.getElementById('jsview-toolbar-menu');
		var csstoolbar = document.getElementById('cssview-toolbar-menu');

		if (js.length > 0) {
			jstoolbar.setAttribute('hidden',false);
			jstoolbar.setAttribute('label',this.getSt('jsview.ExtJs')+" (" +js.length+ ")");
		} else {
			jstoolbar.setAttribute('hidden',true);
		}

		if (css.length > 0) {
			csstoolbar.setAttribute('hidden',false);
			csstoolbar.setAttribute('label',this.getSt('jsview.ExtCss')+" (" +css.length+ ")");
		} else {
			csstoolbar.setAttribute('hidden',true);
		}
	},

	createMenuItems: function(a,b,c) {
		//a=js or css, b=popup id, c=true or false (true will remove existing menu items)

		var list,va,vaU,menu,temp,noname,kb,bytes,prefs,filesize;
		var cacheServ,name,cacheKey,descriptor,pageSize,kbSize,size;

		list = (a=='js') ? this.isJSExternal() : this.isCSSExternal();
		va = (a=='js') ? 'Js' : 'Css';
		vaU = va.toUpperCase();
		menu = document.getElementById(b);

		if (c) {
			while (menu.firstChild) {
				menu.removeChild(menu.firstChild);
			}
		}

		if (!list.length) {
			temp = document.createElement('menuitem');
			temp.setAttribute('label',this.getSt('jsview.'+va+'NF'));
			temp.setAttribute('image','chrome://jsview/skin/none.gif');
			temp.setAttribute('tooltiptext',this.getSt('jsview.'+va+'NF'));
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('disabled','true');
			menu.appendChild(temp);
			return false;
		}

		noname = this.getSt('jsview.NoName');
		kb = this.getSt('jsview.KB');
		bytes = this.getSt('jsview.Bytes');

		prefs = this.getPrefs();
		filesize = prefs.getBoolPref('fileSize');

		cacheServ = this.getCacheService();

		temp = document.createElement('menuitem');
		temp.setAttribute('label',this.getSt('jsview.ViewAll'+va));
		temp.setAttribute('oncommand',"jsviewVS.command('jsviewOpenAll"+vaU+"');");
		temp.setAttribute('image','chrome://jsview/skin/'+a+'.gif');
		temp.setAttribute('tooltiptext',this.getSt('jsview.ViewAll'+va));
		temp.setAttribute('style','font-weight:900;');
		temp.setAttribute('class','menuitem-iconic');
		menu.appendChild(temp);

		for (var i=0; i<list.length; ++i) {
			//remove parameters and add missing filenames
			name = list[i];
			if (name.indexOf('?')!=-1) name = name.substr(0,name.indexOf('?'));
			name = name.substr(name.lastIndexOf('/')+1);
			if (!name) name = '['+noname+']';

			//retrieve file size if cached
			cacheKey = list[i].replace(/#.*$/, "");
			try {
				descriptor = cacheServ.openCacheEntry(cacheKey, Components.interfaces.nsICache.ACCESS_READ, false);
			} catch(e) { descriptor = ''; }
			if (descriptor) {
				pageSize = this.addCommas(descriptor.dataSize);
				kbSize = (descriptor.dataSize / 1024).toFixed(2);
				size = (filesize) ? ' ('+kbSize+' '+kb+')' : ' ('+pageSize+' '+bytes+')';
			} else {
				size = '';
			}

			temp = document.createElement('menuitem');
			temp.setAttribute('label',name+size);
			temp.setAttribute('oncommand',"jsviewVS.command('"+list[i]+"');");
			temp.setAttribute('image','chrome://jsview/skin/'+a+'.gif');
			temp.setAttribute('tooltiptext',list[i]);
			temp.setAttribute('onmouseover',"document.getElementById('statusbar-line-col').label='"+list[i]+"';");
			temp.setAttribute('onmouseout',"document.getElementById('statusbar-line-col').label='"+this.getSt('jsview.Done')+"';");
			temp.setAttribute('class','menuitem-iconic');
			temp.setAttribute('onclick',"if (event.button==1 || event.button==2) {var clip = jsviewVS.getClipboard(); clip.copyString('"+list[i]+"');} return false;");
			if (b.indexOf('toolbar-popup')!=-1) temp.setAttribute('statustext',list[i]);
			if (name=='['+noname+']') temp.setAttribute('style','font-style:italic;');
			menu.appendChild(temp);
		}
		return false;
	},

	getTab: function() {
		var win = this.getMainWin();

		var tab;
		for (var i=0; i<win.gBrowser.mTabs.length; ++i) {
			if (win.gBrowser.mTabs[i].linkedPanel==window.arguments[3]) {
				tab = win.gBrowser.mTabs[i].linkedBrowser.contentWindow;
				break;
			}
		}
		if (!tab) tab = win.content;
		return tab;
	},

	isJSExternal: function() {
		//get correct tab
		var tab = this.getTab();

		var loc = tab.document.location.href;
		var scriptarray = [];
		var allscripts,pages,url,ext;

		allscripts = tab.document.getElementsByTagName('script');
		if (allscripts[0]) {
			for (var i=0; i<allscripts.length; ++i) {
				if (allscripts[i].src && allscripts[i].src!=loc) {
					ext = allscripts[i].src.substr(allscripts[i].src.lastIndexOf('.'));
					if (ext!='.cgi') scriptarray.push(allscripts[i].src);
				}
			}
		}

		pages = tab.parent.frames;
		if (pages.length > 0) {
			for (var m=0; m<pages.length; ++m) {
				url = pages[m].document.location.href;
				allscripts = pages[m].document.getElementsByTagName('script');
				if (allscripts[0]) {
					for (var i=0; i<allscripts.length; ++i) {
						if (allscripts[i].src && allscripts[i].src!=loc && allscripts[i].src!=url) {
							ext = allscripts[i].src.substr(allscripts[i].src.lastIndexOf('.'));
							if (ext!='.cgi') scriptarray.push(allscripts[i].src);
						}
					}
				}
			}
		}

		//check for duplicate entries and remove them
		scriptarray.sort();
		for (var i=0; i<scriptarray.length-1; ++i) {
			while (scriptarray[i]==scriptarray[i+1]) {
				scriptarray.splice(i,1);
			}
		}

		return scriptarray;
	},

	isCSSExternal: function() {
		//get correct tab
		var tab = this.getTab();

		var loc = tab.document.location.href;
		var cssarray = [];
		var sheets,pages,url;

		sheets = tab.document.styleSheets;
		if (sheets.length > 0) {
			for (var i=0; i<sheets.length; ++i) {
				if (sheets[i].href && sheets[i].href!=loc) {
					cssarray.push(sheets[i].href);
				}
				cssarray = cssarray.concat(this.importedCSS(sheets[i]));
			}
		}

		pages = tab.parent.frames;
		if (pages.length > 0) {
			for (var m=0; m<pages.length; ++m) {
				url = pages[m].document.location.href;
				sheets = pages[m].document.styleSheets;
				if (sheets.length > 0) {
					for (var i=0; i<sheets.length; ++i) {
						if (sheets[i].href && sheets[i].href!=loc && sheets[i].href!=url) {
							cssarray.push(sheets[i].href);
						}
						cssarray = cssarray.concat(this.importedCSS(sheets[i]));
					}
				}
			}
		}

		//check for duplicate entries and remove them
		cssarray.sort();
		for (var i=0; i<cssarray.length-1; ++i) {
			while (cssarray[i]==cssarray[i+1]) {
				cssarray.splice(i,1);
			}
		}

		return cssarray;
	},

	importedCSS: function(css) {
		var cssarray = [];
		var rules = css.cssRules;
		for (var j=0; j<rules.length; ++j) {
			if (rules[j].type==3) {
				cssarray.push(rules[j].styleSheet.href);
				cssarray = cssarray.concat(this.importedCSS(rules[j].styleSheet));
			} else { break; }
		}
		return cssarray;
	}
};

var jsviewListen = {
	TL: function() {
		jsviewVS.jsviewToolbar();
	}
};